/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFy[Wt

	Copyright 2015-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: AllocatePages.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		float width = 210.0f; // A4
		float height = 297.0f;// A4c
		PtlRect rectA4V(0.0f, 0.0f, width, height);	// A4cp
		PtlRect rect[4] = {PtlRect(0.0f, height/2, width/2, height),  // ㍶
			               PtlRect(width/2, height/2, width, height), // E
						   PtlRect(0.0f, 0.0f, width/2, height/2),    // 
						   PtlRect(width/2, 0.0f, width, height/2)};  // E
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlPDFDocument doc;
		PtlPDFDocument docNew;

		// VKPDF̃y[WRei̎擾
		PtlPages& pagesNew = docNew.getPages();

		// PDFt@C[h܂B
		doc.load(input);

		// PDF̃y[WRei̎擾
		PtlPages& pages = doc.getPages();

		int numPages = doc.getPageCount();

		int pageNumber = 0;
		int i=0;
		while (i<numPages) {
			// tsA4cy[W
			PtlPage pageTemp;
			pageTemp.setViewBox(rectA4V);
			// y[W𕶏ɒǉ
			pagesNew.append(pageTemp, PtlPages::OPTION_NONE);

			// y[W̎擾
			PtlPage pageNew = pagesNew.get(pageNumber);

			// tsA4cy[W̃Reg擾
			PtlContent& content = pageNew.getContent();

			// 4y[W1y[WɊt܂B
			for(int j=0; j<4 && i<numPages; ++j,++i) {
				// ty[W
				PtlPage page = pages.get(i);
				// y[Wt
				content.drawForm(rect[j], PtlContent::ALIGN_CENTER, page);
			}

			++pageNumber;
		}

		// t@Cɕۑ܂B
		docNew.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
	}	
	return 0;
}
