/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFN߂̍쐬

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void addAnnotLink(PtlPages& pages, PtlPage& page, char actionKind);
void setAction(PtlPages& pages, PtlAnnotLink& annotlink, char actionKind);

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: AppendAnnotLink.exe in-pdf-file out-pdf-file ANV̎\n\n");
		printf("ANV̎\n0 : GOTOANV̐ݒ\n1 : GOTORANV̐ݒ\n2 : LaunchANV̐ݒ\n3 : URIANV̐ݒ\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		const char* actionKind = argv[3];
		switch (actionKind[0]) {
		case '0':
		case '1':
		case '2':
		case '3':
			break;
		default:
			printf("usage: AppendAnnotLink.exe in-pdf-file out-pdf-file ANV̎\n\n");
			printf("ANV̎\n0 : GOTOANV̐ݒ\n1 : GOTORANV̐ݒ\n2 : LaunchANV̐ݒ\n3 : URIANV̐ݒ\n");
			return 1;
		}

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		// y[WRei󂩂ǂ
		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// Py[Wڂ̎擾
		PtlPage page = pages.get(0);
		
		// ߂̒ǉ
		addAnnotLink(pages, page, actionKind[0]);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void addAnnotLink(PtlPages& pages, PtlPage& page, char actionKind)
{
	// ߃Rei̎擾
	PtlAnnots& annots = page.getAnnots();
		
	// PDF̃N
	PtlAnnotLink annotlink;

	// `Wݒ
	annotlink.setRect(PtlRect(30.0f,30.0f,50.0f,50.0f));

	// eݒ
	annotlink.setTextContents("PDF̃N");

	// ANV̐ݒ
    setAction(pages, annotlink, actionKind);

	//߂̒ǉ
	annots.append(annotlink);
}

void setAction(PtlPages& pages, PtlAnnotLink& annotlink, char actionKind)
{
	// ̐ݒ
	PtlDestFit destfit;
	// y[W̐ݒiŏIy[WɁj
	destfit.setPageNumber(pages.getCount() - 1);

	switch (actionKind) {
	case '0':
		{
			// GOTOANV̐ݒ
			PtlActionGoTo acttiongoto;
			// ̐ݒ
			acttiongoto.setDest(destfit);
			// ANV̐ݒ
			annotlink.setAction(acttiongoto);
			break;
		}
	case '1':
		{
			// GOTORANV̐ݒ
			PtlActionGoToR actiongotor; 
			// ̐ݒ
			actiongotor.setDest(destfit);
			// t@CԈړpPDFt@Cݒ
			actiongotor.setFileName("test.pdf");
			// VEBhEtOݒ
			actiongotor.setNewWindowFlag(true);
			// ANV̐ݒ
			annotlink.setAction(actiongotor);
			break;
		}
	case '2':
		{
			// LaunchANV̐ݒ
			PtlActionLaunch actionlaunch;
			// Nt@Cݒ
			actionlaunch.setFileName("test.txt");
			// VEBhEtOݒ
			actionlaunch.setNewWindowFlag(true);
			// ANV̐ݒ
			annotlink.setAction(actionlaunch);
			break;
		}
	case '3':
		{
			// URIANV̐ݒ
			PtlActionURI actionurl;
			// URIݒ
			actionurl.setURI("http://www.antenna.co.jp/");
			// ANV̐ݒ
			annotlink.setAction(actionurl);
		}
	}
}
