/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFeLXg߂̍쐬

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void addAnnotText(PtlPage& page);

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: AppendAnnotText.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		// y[WRei󂩂ǂ
		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// Py[Wڂ̎擾
		PtlPage page = pages.get(0);

		// ߂̒ǉ		
		addAnnotText(page);
		PtlContent content = page.getContent();
		PtlParamWriteString param;
		PtlParamFont font;
		param.setFont(font);
		content.writeString(PtlRect(0.0, 0.0, 100.0, 100.0), PtlContent::ALIGN_CENTER, "test",param);
		doc.setSaveOption(PtlPDFDocument::SAVE_INCREMENTAL_UPDATE);
		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

void addAnnotText(PtlPage& page)
{
	// ߃Rei̎擾 PtlPage::getAnnots
	PtlAnnots& annots = page.getAnnots();

	// PDF̃eLXg
	PtlAnnotText annottext;

	//------------------------------------------------------------

	// ACR^Cvݒ ICON_COMMENT = 1, /* Rg */
	annottext.setIconType(PtlAnnotText::ICON_NOTE);

	// ACRTCY
	PtlRect rectSize = annottext.getRect();

	// `Wݒ W̒PʂmmŌ_(0,0)͍
	annottext.setRect(PtlRect(50.0f, 50.0f, 50.0f+rectSize.getRight(), 50.0f+rectSize.getTop()));

	// eݒiߗpɕ\eLXgEǂȌ`ł̒߃Rec̑֐j
	annottext.setTextContents("ǂȌ`ł̒߃Rec̑֐");

	// ̐ݒ(2013/01/01 00:00:00)
	annottext.setDate(PtlDate(2013, 1, 1, 0, 0, 0));

	// ߃tOݒi_aj FLAG_NOROTATE = 0x00000010, /* ߂̊Oςy[Wɂ킹ĉ]܂B */
	annottext.setAnnotFlags(PtlAnnotText::FLAG_NOROTATE);

	// Fݒ setColor(const PtlColorDeviceRGB& color);
	annottext.setColor(PtlColorDeviceRGB(0.0f, 0.0f, 1.0f));

	// EX^Cݒ BORDER_SOLID = 1, /* (߂͂ގ̋`) */
	annottext.setBorderStyle(PtlAnnotText::BORDER_SOLID);

	// Eݒ BORDER_WIDTH_THIN = 1, /* ׂ */
	annottext.setBorderWidth(PtlAnnotText::BORDER_WIDTH_THIN);

	//------

	// |bvAbvEBhẼ^Cgݒ
	annottext.setMarkUpTitle("|bvAbvEBhẼ^Cg");

	// TuWFNg̒Zݒ
	annottext.setMarkUpSubj("TuWFNg̒Zݒ");

	// ߐ̐ݒ(2012/12/31 23:59:59)
	annottext.setMarkUpDate(PtlDate(2012, 12 , 31, 23, 59, 59));

	// sxݒ 0.0 ` 1.0B0.0A1.0s
	annottext.setMarkUpCA(0.8f);

	//------

	//PtlAnnotPopup
	PtlAnnotPopup annotpopup;

	// `Wݒ W̒PʂmmŌ_(0,0)͍
	annotpopup.setRect(PtlRect(100.0f, 50.0f, 150.0f, 150.0f)); 

	// I[vԂݒ true=I[v
	annotpopup.setOpenState(true);

	// |bvAbv߂ݒ
	annottext.setAnnotPopUp(annotpopup);

	//------


	// ߂̒ǉ
	annots.append(annottext);
}

