/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFZLeB

	Copyright 2015-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: Decrypt.exe in-pdf-file out-pdf-file in-pdf-password\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlParamString password(argv[3]);
		PtlPDFDocument doc;

		// pX[h̃Zbg
		doc.setPassword(password);

		// PDFt@C[h܂B
		doc.load(input);

		// Í̎擾
		if (doc.isEncrypted()) {
			if (doc.hasOwnerAuthority()) {
				// Í̍폜
				doc.removeEncrypt();
			} else {
				printf("pX[hɏ܂\n");
				return 0;
			}
		} else {
		    printf("ÍĂȂt@Cł\n");
			return 0;
		}

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}
