/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF摜̕`

	Copyright 2015-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void drawImage(PtlPage& page, const char* pathImage);

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: DrawImage.exe in-pdf-file out-pdf-file insert-image-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// 擪y[W̎擾
		PtlPage page = pages.get(0);

		// 摜̕`
		drawImage(page, argv[3]);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void drawImage(PtlPage& page, const char* pathImage)
{
	// }摜
	PtlParamInput insertImage(pathImage);

	// y[WReg̎擾
	PtlContent& content = page.getContent();

	// y[WTCY
	PtlSize pageSize = page.getSize();

	// ``
	PtlRect rect(10.0f, 10.0f, pageSize.getWidth()-10.0f, pageSize.getHeight()-10.0f);

	// 摜̕`Ɏgp[^NX
	PtlParamDrawImage paramDrawImage;

	// ͉摜Xg[̐ݒ
	paramDrawImage.setImageStream(insertImage);

	// }`Tiff̃y[Wԍ̐ݒiTifft@Cɂ̂ݗLj 
	paramDrawImage.setImagePageNumber(0);

	// 摜̕`
	content.drawImage(rect, PtlContent::ALIGN_TOP_LEFT, paramDrawImage);
}
