/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFC[̕`

	Copyright 2018-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void drawLayer(PtlPage& page, const char* pathPdf);

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: DrawLayer.exe in-pdf-file out-pdf-file in-pdf-file2\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// 擪y[W̎擾
		PtlPage page = pages.get(0);

		// C[̕`
		drawLayer(page, argv[3]);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void drawLayer(PtlPage& page, const char* pathPdf)
{
	// y[WTCY
	PtlSize pageSize = page.getSize();
	// y[WReg̎擾
	PtlContent& content = page.getContent();

	// ``
	PtlRect rect(0.0f, 0.0f, pageSize.getWidth(), pageSize.getHeight());

	// C[ɐݒ肷PDF
	PtlParamInput input2(pathPdf);

	PtlPDFDocument doc2;

	// PDFt@C[h܂B
	doc2.load(input2);

	// y[WRei̎擾
	PtlPages& pages2 = doc2.getPages();
	if (pages2.isEmpty()){
		printf("y[WRei\n");
		return;
	}

	// 擪y[W̎擾
	PtlPage pageInsert = pages2.get(0);

	// C[̃p[^[
	PtlParamDrawLayer param;
	// C[ɂy[W
	param.setPage(pageInsert);
	// C[̖O
	param.setName("C[");
	// C[Oʂ
	param.setZorder(PtlParamDrawLayer::ZORDER_FRONT);
	// C[\
	param.setShow(PtlParamDrawLayer::SHOW_ON);

	// C[̕`
	content.drawLayer(rect, PtlContent::ALIGN_CENTER, param);
}
