/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF摜o

	Copyright 2018 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void extractImage(PtlPage& page, const char* imagefilename, char kind);

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: ExtractImage.exe in-pdf-file out-image-file o̓tH[}bg\n\n");
		printf("o̓tH[}bg\n0 :   1 : BMP  2 : JPEG  3 : PNG\n");
		return 1;
	}

	const char* kind = argv[3];
	switch (kind[0]) {
	case '0':
	case '1':
	case '2':
	case '3':
		break;
	default:
		return 1;
	}

	try
	{
		PtlParamInput input(argv[1]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// 擪y[W̎擾
		PtlPage page = pages.get(0);

		// 摜o
		extractImage(page, argv[2], kind[0]);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void extractImage(PtlPage& page, const char* imagefilename, char kind)
{
	int numImage = 0;
	// y[WReg̎擾
	PtlContent& content = page.getContent();
	// 摜Gg̎擾
	PtlEditElements& elems = content.getEditElements(PtlContent::GET_IMAGE);
	int numElems = elems.getCount();
	if (numElems == 0) return;

	PtlEditImage::OUTPUT_FORMAT format = PtlEditImage::FORMAT_AUTO;
	switch (kind) {
	case '1':
		format = PtlEditImage::FORMAT_BMP; 
		break;
	case '2':
		format = PtlEditImage::FORMAT_JPEG;
		break;
	case '3':
		format = PtlEditImage::FORMAT_PNG;
		break;
	}
	for (int i=0; i<numElems; ++i) {
		// 摜Gg̎擾
		PtlEditElement& elem = elems.get(i);
		PtlEditElement::ELEMENT_TYPE type = elem.getType();
		switch (type) {
		case PtlEditElement::TYPE_IMAGE:
			{
				++numImage;
				PtlEditImage& elemImage = (PtlEditImage&)elem;
				char pathImage[256] = {'\0'};
				switch (format) {
				case PtlEditImage::FORMAT_AUTO:
					sprintf(pathImage, "%s%d", imagefilename, numImage);
					break;
				case PtlEditImage::FORMAT_BMP:
					sprintf(pathImage, "%s%d.bmp", imagefilename, numImage);
					break;
				case PtlEditImage::FORMAT_JPEG:
					sprintf(pathImage, "%s%d.jpg", imagefilename, numImage);
					break;
				case PtlEditImage::FORMAT_PNG:
					sprintf(pathImage, "%s%d.png", imagefilename, numImage);
					break;
				}
				PtlParamOutput output(pathImage);
				elemImage.writeFile(output, format);
			}
			break;
		default:
			break;
		}
	}
}
