/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFeLXgGg擾

	Copyright 2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void extractText(PtlPage& page);

int main(int argc, char* argv[])
{
	if (argc < 2) {
		printf("usage: ExtractTextElem.exe in-pdf-file\n");
		return 1;
	}

	try
	{
		PtlParamInput input(argv[1]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// 擪y[W̎擾
		PtlPage page = pages.get(0);

		// eLXgo
		extractText(page);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}
	return 0;
}

void extractText(PtlPage& page)
{
	// y[WReg̎擾
	PtlContent& content = page.getContent();
	// eLXgGg̎擾
	PtlEditElements& elems = content.getEditElements(PtlContent::GET_TEXT);
	int numElems = elems.getCount();
	if (numElems == 0) return;
	for (int i=0; i<numElems; ++i) {
		PtlEditElement& elem = elems.get(i);
		PtlEditText& elemText = (PtlEditText&)elem;
		// eLXgACe̎擾
		PtlEditTextItems& elemTextItems = elemText.getTextItems();
		int numItems = elemTextItems.getCount();
		for (int j=0; j<numItems; ++j) {
			PtlEditTextItem& textItem = elemTextItems.get(j);
			// eLXg
			PtlParamString text = textItem.getText();
			const char* c_str = text.c_str();
			//printf("%s\n", c_str);
			// eLXg͂ދ`
			PtlRect bbox = textItem.getBBox();
			float left = bbox.getLeft();
			float top = bbox.getTop();
			float right = bbox.getRight();
			float bottom = bbox.getBottom();
			// eLXg͂4_̍W
			PtlQuadPoint quadPoint = textItem.getQuadPoint();
			PtlPoint& bottomLeft = quadPoint.getBottomLeft();
			float bl_x= bottomLeft.getX();
			float bl_y= bottomLeft.getY();
			PtlPoint& topLeft = quadPoint.getTopLeft();
			float tl_x= topLeft.getX();
			float tl_y= topLeft.getY();
			PtlPoint& topRight = quadPoint.getTopRight();
			float tr_x= topRight.getX();
			float tr_y= topRight.getY();
			PtlPoint& bottomRight = quadPoint.getBottomRight();
			float br_x= bottomRight.getX();
			float br_y= bottomRight.getY();
		}
	}
}
