/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFJ̎擾

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 2) {
		printf("usage: GetDocInfo.exe in-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		//PDF̕vpeB
		PtlDocProperty& docproperty = doc.getDocProperty();

		//PDF̕
		PtlDocInfo& docinf = docproperty.getDocInfo();

		//^Cg擾
		PtlParamString title = docinf.getTitle();
		printf("Title : %s\n", title.c_str());

		//Ҏ擾
		PtlParamString author = docinf.getAuthor();
		printf("Author : %s\n", author.c_str());

		//TuWFNg擾
		PtlParamString subject = docinf.getSubject();
		printf("Subject : %s\n", subject.c_str());

		//L[[h擾
		PtlParamString keywords = docinf.getKeywords();
		printf("Keywords : %s\n", keywords.c_str());

		//NG[^擾
		PtlParamString creator = docinf.getCreator();
		printf("Creator : %s\n", creator.c_str());

		//vf[T擾
		PtlParamString producer = docinf.getProducer();
		printf("Producer : %s\n", producer.c_str());

		//쐬t擾
		PtlDate creationDate = docinf.getCreationDate();
		printf("CreationDate : %d/%d/%d %d:%d:%d\n"
			, creationDate.getYear()
			, creationDate.getMonth()
			, creationDate.getDay()
			, creationDate.getHour()
			, creationDate.getMin()
			, creationDate.getSec());

		//XVt擾
		PtlDate modDate = docinf.getModDate();
		printf("ModDate : %d/%d/%d %d:%d:%d\n"
			, modDate.getYear()
			, modDate.getMonth()
			, modDate.getDay()
			, modDate.getHour()
			, modDate.getMin()
			, modDate.getSec());

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
	}	
	return 0;
}

