/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF摜t@CPDF(\tg}XN)

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: ImageToPdfSMask.exe append-image-file mask-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput inputImage(argv[1]);
		PtlParamInput inputMask(argv[2]);
		PtlParamOutput output(argv[3]);

		PtlPDFDocument doc;

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		// 摜̃y[W쐬Ɏgp[^NX
		PtlParamImagePage paramImagePage;

		// 摜̕`Ɏgp[^NX
		PtlParamDrawImage paramDrawImage;

		// \tg}XN
		paramDrawImage.setMaskImageStream(inputMask, PtlParamDrawImage::MASK_SOFT);

		// ͉摜Xg[̐ݒ
		paramDrawImage.setImageStream(inputImage);

		// y[Wɑ}摜p[^̐ݒB
		paramImagePage.setImage(paramDrawImage);

		// p^Cv̐ݒ  PAPER_IMAGE_SIZE /* 摜TCYɍ킹 */
		paramImagePage.setPaperType(PtlParamImagePage::PAPER_IMAGE_SIZE);

		// y[W̒ǉ
		pages.append(paramImagePage);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

