/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF߂̍폜

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: RemoveAnnots.exe in-pdf-file out-pdf-fil 폜@\n\n");
		printf("폜@\n0 : ЂƂ߂̒߂̍폜 1 : S߂̍폜\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		const char* kind = argv[3];
		switch (kind[0]) {
		case '0':
		case '1':
			break;
		default:
			printf("usage: RemoveAnnots.exe in-pdf-file out-pdf-fil 폜@\n\n");
			printf("폜@\n0 : ЂƂ߂̒߂̍폜 1 : S߂̍폜\n");
			return 1;
		}

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// y[WRei̎擾
		PtlPages& pages = doc.getPages();

		// y[WRei󂩂ǂ
		if (pages.isEmpty()){
			printf("y[WRei\n");
			return 1;
		}

		// 1y[W̎擾
		PtlPage page = pages.get(0);
		
		//߃Rei̎擾
		PtlAnnots& annots = page.getAnnots();

		//߃Rei󂩂ǂ
		if (annots.isEmpty()){
			printf("߂Ȃ\n");
		} else {
			// ߐ̎擾
			int numAnnots = annots.getCount();
			printf("ߐ : %d\n", numAnnots);
			switch (kind[0]) {
			case '0':
				// ߂̍폜
				annots.remove(0);
				break;
			case '1':
				// S߂̍폜
				annots.removeAll();
				break;
			}
		}

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}
