/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFYtt@C̍폜

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: RemoveEmbeddedFile.exe in-pdf-file out-pdf-file 폜@\n\n");
		printf("폜@\n0 : Ytt@C̍폜 1 : Ytt@C̑S폜\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		const char* kind = argv[3];
		switch (kind[0]) {
		case '0':
		case '1':
			break;
		default:
			printf("usage: RemoveEmbeddedFile.exe in-pdf-file out-pdf-file 폜@\n\n");
			printf("폜@\n0 : Ytt@C̍폜 1 : Ytt@C̑S폜\n");
			return 1;
		}

		PtlPDFDocument doc;

		// PDFtB[h܂B
		doc.load(input);

		// Ytt@CRei̎擾
		PtlEmbeddedFiles& embeddedfiles = doc.getEmbeddedFiles();

		// Ytt@CRei󂩂ǂ
		if (embeddedfiles.isEmpty()) {
			printf("Ytt@CRei\n");
			return 1;
		}

		// Ytt@C̎擾
		printf("Ytt@C : %d\n", embeddedfiles.getCount());

		switch (kind[0]) {
		case '0':
			// Ytt@C̍폜
			embeddedfiles.remove(0);
			break;
		case '1':
			// Ytt@C̑S폜
			embeddedfiles.removeAll();
			break;
		}

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}
