/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF̍폜

			̃Tvł͉Ls܂B
			EKw̍ŏ̂̃ANV폜
			EKw2Ԗڂ̂̎qSĂ폜
			EKw3Ԗڂ̂yт̎qSĂ폜

	Copyright 2013-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

void removeOutline(PtlOutline& item);

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: RemoveOutline.exe in-pdf-file out-pdf-file\n");
		return 1;
	} 
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		//AEgCĂ邩ǂ
		if (!doc.hasOutlines()){
			printf("AEgCĂȂ\n");
			return 1;
		}

		//[gAEgC̎擾
		PtlOutline rootOutline = doc.getRootOutline();

		if (rootOutline.hasChild()) {
			//ŏ̎qAEgC̎擾
			PtlOutline outline = rootOutline.getFirstChild();
			removeOutline(outline);
		}

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

void removeOutline(PtlOutline& item)
{
	// ŏ̎qAEgC̎擾
	printf("- %s\n", item.getTitle().c_str());
	// ANV̍폜
	printf("u%sṽANV폜...\n", item.getTitle().c_str());
	item.removeAction();

	// ̌ZAEgC̎擾
	PtlOutline item2;
	try
	{
		item2 = item.getNextSibling();
	}
	catch (const PtlException &e)
	{
		if (e.getErrorCode() != PtlErrorCode::NO_OBJECT) {
			fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		}
		return;
	}
	printf("- %s\n", item2.getTitle().c_str());
	// qAEgC̍폜
	printf("u%sv̎q폜...\n", item2.getTitle().c_str());
	item2.removeChildren();

	// ̌ZAEgC̎擾
	PtlOutline item3;
	try
	{
		item3 = item2.getNextSibling();
	}
	catch (const PtlException &e)
	{
		if (e.getErrorCode() != PtlErrorCode::NO_OBJECT) {
			fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		}
		return;
	}
	printf("- %s\n", item3.getTitle().c_str());
	// gyюqAEgC̍폜
	printf("u%svƎq폜...\n", item3.getTitle().c_str());
	item3.destroy();
}
