/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvFeLXgă}XN

	Copyright 2018 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 4) {
		printf("usage: SearchTextAndMaskAuto.exe in-pdf-file out-pdf-file keyword\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);
		PtlParamString keyword(argv[3]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		// ׂ̈̃p[^
		PtlParamSearchTextAndSetMask paramSearchText;

		paramSearchText.appendText(keyword);
		paramSearchText.setTextType(PtlParamSearchText::TEXT_RAW);
		PtlColorDeviceRGB color(1.0f, 0.0f, 0.0f);
		paramSearchText.setColor(color);
		paramSearchText.setOpacity(0.5f);

		// s
		doc.searchTextAndDoProcess(paramSearchText);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

