/*
	Antenna House PDF Tool API V7.0
	C++ Interface sample program

	TvF}XN̐ݒ

	Copyright 2015-2021 Antenna House, Inc.
*/

#include <PdfTk.h>
#include <stdio.h>

using namespace PdfTk;

int main(int argc, char* argv[])
{
	if (argc < 3) {
		printf("usage: SetMask.exe in-pdf-file out-pdf-file\n");
		return 1;
	}
	try
	{
		PtlParamInput input(argv[1]);
		PtlParamOutput output(argv[2]);

		PtlPDFDocument doc;

		// PDFt@C[h܂B
		doc.load(input);

		int numPages = doc.getPageCount();

		PtlPages& pages = doc.getPages();

		// 擪y[W̎擾
		PtlPage page0 = pages.get(0);

		// y[WTCY
		PtlSize pageSize = page0.getSize();

		// }XNݒ
		PtlParamSetMask paramSetMask;
		PtlRect rect(pageSize.getWidth()/4.0f, pageSize.getHeight()/4.0f, pageSize.getWidth()*3.0f/4.0f, pageSize.getHeight()*3.0f/4.0f);
		paramSetMask.appendRect(rect);
		PtlColorDeviceRGB color(1.0f, 0.0f, 0.0f);
		paramSetMask.setMaskColor(color);
		page0.setMask(paramSetMask);

		// t@Cɕۑ܂B
		doc.save(output);

		printf("!\n");
	}
	catch (const PtlException &e)
	{
		fprintf(stderr, "Error code : %d\n %s\n", e.getErrorCode(), e.getErrorMessage().c_str());
		return 1;
	}	
	return 0;
}

